(defun C:Cut_RD@Point ( / js ent obj tbl tbl_od AcDoc pt_brk name_rd pt_start pt_end js_pl npl elist xd_list pl_data obj_data pr_brk typ_pr data_lst-pl partialcum distcum other_data tbldef nwent nwobj)
	(setq AcDoc (vla-get-ActiveDocument (vlax-get-acad-object)))
	(vlax-for l (vla-get-layers AcDoc)
		(if (eq (vlax-get l 'Name) "&METADATA")
			(progn
				(vla-put-Freeze l :vlax-false)
				(vla-put-Lock l :vlax-false)
				(vla-put-Color l 7)
				(vla-put-LayerOn l 1)
			)
		)
	)
	(vla-Regen AcDoc acActiveViewport)
	(princ "\nSlectionner la voie  couper.")
	(while (setq js (ssget "_+.:E:S" '((0 . "LWPOLYLINE") (100 . "AcDbEntity") (67 . 0) (410 . "Model") (8 . "Reseau Acces Emetteurs,Reseau d_Interet Economique et Touristique,Reseau d_Interet Local,Reseau Ossature,Reseau National,Reseau Voie Ferree,Voie Verte") (100 . "AcDbPolyline")  (210 0.0 0.0 1.0))))
		(cond
			(js
				(setvar "CMDECHO" 0)
				(setq
					ent (ssname js 0)
					obj (vlax-ename->vla-object ent)
				)
				(cond
					((setq tbl (ade_odgettables ent))
						(setq
							tbl_od (car (vl-remove-if-not '(lambda (x) (member x '("RD_METADATA" "VF_METADATA" "VR_METADATA"))) tbl))
						)
						(cond
							(tbl_od
								(initget 9)
								(setq
									pt_brk (getpoint "\nPoint o couper la voie?: ")
									pt_brk (vlax-curve-getClosestPointTo obj (trans pt_brk 1 0))
									name_rd (ade_odgetfield ent tbl_od (strcat (substr tbl_od 1 3) "LABEL") 0)
									pt_start (vlax-curve-getStartPoint obj)
									pt_end (vlax-curve-getEndPoint obj)
									js_pl (ssget "_C" (mapcar '- pt_brk '(0.05 0.05 0.0)) (mapcar '+ pt_brk '(0.05 0.05 0.0)) (append '((0 . "LWPOLYLINE") (100 . "AcDbEntity") (67 . 0) (410 . "Model") (8 . "&METADATA") (100 . "AcDbPolyline")  (210 0.0 0.0 1.0)) (list (cons -3 (list (list tbl_od))))))
								)
								(cond
									(js_pl
										(setq npl (sslength js_pl))
										(while (>= npl 1)
											(setq elist (entget (ssname js_pl (setq npl (1- npl))) (list tbl_od)))
											(if (not (eq (cdar (cdadr (assoc -3 elist))) name_rd))
												(ssdel (ssname js_pl npl) js_pl)
												(setq xd_list (cdadr (assoc -3 elist)))
											)
										)
										(cond
											((and (not (equal pt_brk pt_start 1E-05)) (not (equal pt_brk pt_end 1E-05)) js_pl)
												(setq
													pl_data (ssname js_pl 0)
													obj_data (vlax-ename->vla-object pl_data)
													elist (entget pl_data (list tbl_od))
													xd_list (cdadr (assoc -3 elist))
													pr_brk (vlax-curve-getDistAtPoint obj_data (vlax-curve-getClosestPointTo obj_data pt_brk))
													pr_brk (+ (cdaddr xd_list) (/ (fix (atof (rtos pr_brk 2 0))) 10000.0 ))
													typ_pr
													(cond
														((or (eq (substr tbl_od 1 3) "RD_") (eq (substr tbl_od 1 3) "VR_")) "PR_")
														((eq (substr tbl_od 1 3) "VF_") "PK_")
													)
												)
												(setq
													data_lst-pl
													(mapcar
														'(lambda (x) (ade_odgetfield ent tbl_od x 0))
														(list (strcat (substr tbl_od 1 3) "LABEL") (strcat (substr tbl_od 1 3) "CLASS") (strcat typ_pr "ORI") (strcat typ_pr "FIN") "LONG_SECT" "CUMDEB_SECT" "CUMFIN_SECT")
													)
													partialcum (vlax-curve-getDistAtPoint obj pt_brk)
													distcum (+ (nth 5 data_lst-pl) partialcum)
													other_data nil
												)
												(foreach n (ade_odgettables ent)
													(cond
														((/= n tbl_od)
															(setq tbldef (ade_odtabledefn n))
															(setq other_data (cons (mapcar '(lambda (fld) (cons n (cons fld (ade_odgetfield ent n fld 0)))) (mapcar 'cdar (cdr (nth 2 tbldef)))) other_data))
														)
													)
												)
												(command "_.break" ent "_none" (trans pt_brk 0 1) "_none" (trans pt_brk 0 1))
												(setq nwent (entlast) nwobj (vlax-ename->vla-object nwent))
												(ade_odsetfield ent tbl_od (strcat typ_pr "FIN") 0 pr_brk)
												(ade_odsetfield ent tbl_od "LONG_SECT" 0 (vlax-curve-getDistAtPoint obj pt_brk))
												(ade_odsetfield ent tbl_od "CUMFIN_SECT" 0 (+ (nth 5 data_lst-pl) (vlax-curve-getDistAtPoint obj pt_brk)))
												(ade_odaddrecord nwent tbl_od)
												(mapcar
													'(lambda (x y) (ade_odsetfield nwent tbl_od x 0 y))
													(list (strcat (substr tbl_od 1 3) "LABEL") (strcat (substr tbl_od 1 3) "CLASS") (strcat typ_pr "ORI") (strcat typ_pr "FIN") "LONG_SECT" "CUMDEB_SECT" "CUMFIN_SECT")
													data_lst-pl
												)
												(ade_odsetfield nwent tbl_od (strcat typ_pr "ORI") 0 pr_brk)
												(ade_odsetfield nwent tbl_od "LONG_SECT" 0 (vlax-curve-getDistAtParam nwobj (vlax-curve-getEndParam nwobj)))
												(ade_odsetfield nwent tbl_od "CUMDEB_SECT" 0 (+ (nth 5 data_lst-pl) (vlax-curve-getDistAtPoint obj pt_brk)))
												(cond
													(other_data
														(mapcar '(lambda (x) (ade_odaddrecord nwent (caar x)) (foreach el x (ade_odsetfield nwent (car el) (cadr el) 0 (cddr el)))) other_data)
													)
												)
												(alert
													(apply 'strcat
														(mapcar 'strcat
															(mapcar 'strcat 
																'("\n" "\n" "\n" "\n" "\n" "\n" "\n")
																'("LABEL" "CLASS" "ORI" "FIN" "LG_SECT" "CUMDEB" "CUMFIN")
																'("=" "=" "=" "=" "=" "=" "=")
																(mapcar '(lambda (x) (if (numberp x) (rtos x 2 2) x)) data_lst-pl)
															)
															(mapcar 'strcat 
																'("\t" "\t" "\t\t" "\t\t" "\t" "\t" "\t")
																'("LABEL" "CLASS" "ORI" "FIN" "LG_SECT" "CUMDEB" "CUMFIN")
																'("=" "=" "=" "=" "=" "=" "=")
																(mapcar '(lambda (x) (if (numberp x) (rtos x 2 2) x))
																	(mapcar
																		'(lambda (x) (ade_odgetfield ent tbl_od x 0))
																		(list (strcat (substr tbl_od 1 3) "LABEL") (strcat (substr tbl_od 1 3) "CLASS") (strcat typ_pr "ORI") (strcat typ_pr "FIN") "LONG_SECT" "CUMDEB_SECT" "CUMFIN_SECT")
																	)
																)
															)
															(mapcar 'strcat 
																'("\t" "\t" "\t\t" "\t\t" "\t" "\t" "\t")
																'("LABEL" "CLASS" "ORI" "FIN" "LG_SECT" "CUMDEB" "CUMFIN")
																'("=" "=" "=" "=" "=" "=" "=")
																(mapcar '(lambda (x) (if (numberp x) (rtos x 2 2) x))
																	(mapcar
																		'(lambda (x) (ade_odgetfield nwent tbl_od x 0))
																		(list (strcat (substr tbl_od 1 3) "LABEL") (strcat (substr tbl_od 1 3) "CLASS") (strcat typ_pr "ORI") (strcat typ_pr "FIN") "LONG_SECT" "CUMDEB_SECT" "CUMFIN_SECT")
																	)
																)
															)
														)
													)
												)
											)
											(T
												(princ (strcat "\n*** La " name_rd " est dj coupe  ce point! ***"))
											)
										)
									)
									(T
										(princ (strcat "\nPROBLEME DE SELECTION AVEC LA " name_rd " Essayer avec un zoom plus loign."))
									)
								)
							)
						)
					)
					(T
						(princ "\nPas de donnes d'objet! Utiliser la commande COUPURE standar d'Autocad")
					)
				)
				(setvar "CMDECHO" 1)
			)
			(T
				(princ "\nCette voie n'appartient pas au rseau gr par le dpartement")
			)
		)
		(princ "\nSlectionner la voie  couper.")
	)
	(vlax-for l (vla-get-layers AcDoc)
		(if (eq (vlax-get l 'Name) "&METADATA")
			(progn
				(vla-put-Freeze l :vlax-true)
				(vla-put-Lock l :vlax-true)
				(vla-put-Color l 7)
				(vla-put-LayerOn l 0)
			)
		)
	)
	;(vla-Regen AcDoc acActiveViewport)
	(prin1)
)